--[[
  MoveAnything! by Wagthaa<Savage Tribe> of Earthen Ring EU
  
  Based upon the ashes of:
		MoveAnything! V.2.66 by Vincent
		MoveAnything! vJ.11000.2 by Jason
		MA! 1.12 by Skrag
]]

local function Error( msg )
	maPrint( msg );--, 1.0, 0.2, 0.2
end

local function void() end

MADB = {
	collapsed = false,
}

MovAny = {
	guiLines = -1,

	bagFrames = {},
	cats = {},
	createBeforeMove = {
		AchievementAlertFrame1 = "AchievementAlertFrameTemplate",
		AchievementAlertFrame2 = "AchievementAlertFrameTemplate",
		GroupLootFrame1 = "GroupLootFrameTemplate",
		GroupLootFrame2 = "GroupLootFrameTemplate",
		GroupLootFrame3 = "GroupLootFrameTemplate",
		GroupLootFrame4 = "GroupLootFrameTemplate",
		--WorldStateCaptureBar1 = "WorldStateCaptureBarTemplate",
	},
	runBeforeMove = {
		AchievementAlertFrame1 = AchievementFrame_LoadUI,
		AchievementAlertFrame2 = AchievementFrame_LoadUI,
		AchievementFrame = AchievementFrame_LoadUI,
		AuctionFrame = AuctionFrame_LoadUI,
		BattlefieldMinimap = BattlefieldMinimap_LoadUI,
		BarberShopFrame = function() BarberShopFrame_LoadUI() ShowUIPanel(BarberShopFrame) HideUIPanel(BarberShopFrame) end,
		ClassTrainerFrame = ClassTrainerFrame_LoadUI,
		GMSurveyFrame = GMSurveyFrame_LoadUI,
		GuildBankFrame = GuildBankFrame_LoadUI,
		InspectFrame = InspectFrame_LoadUI,
		PlayerTalentFrame = TalentFrame_LoadUI,
		MacroFrame = MacroFrame_LoadUI,
		TradeSkillFrame = TradeSkillFrame_LoadUI,
		TimeManagerClockButton = TimeManager_LoadUI,
	},
	defFrames = {},
	frameListSize = 13,
	frames = {},
	framesCount = 0,
	framesIdx = {},
	framesUnsupported = {},
	initRun = false,
	lastFrameName = nil,
	lEnableMouse = {
		WatchFrame,
		AchievementWatchFrame,
		DurabilityFrame,
		WorldStateAlwaysUpFrame,
		CastingBarFrame,
		ReputationWatchBar,
	},
	lSimpleHide = {
		MainMenuBarLeftEndCap = true,
		MainMenuBarRightEndCap = true,
	},
	lTranslate = {
		minimap = "MinimapCluster",
		tooltip = "TooltipMover",
		player = "PlayerFrame",
		target = "TargetFrame",
		targetoftarget = "TargetofTargetFrame",
		pet = "PetFrame",
		focus = "FocusFrame",
		bags = "BagButtonsMover",
		keyring = "KeyRingFrame",
		GameTooltip = "TooltipMover",
	},
	lTranslateSec = {
		MainMenuBarBackpackButton = "BagButtonsMover",
		CharacterBag0Slot = "BagButtonsMover",
		CharacterBag1Slot = "BagButtonsMover",
		CharacterBag2Slot = "BagButtonsMover",
		CharacterBag3Slot = "BagButtonsMover",
		
		CharacterMicroButton = "MicroButtonsMover",
		SpellbookMicroButton = "MicroButtonsMover",
		TalentMicroButton = "MicroButtonsMover",
		AchievementMicroButton = "MicroButtonsMover",
		QuestLogMicroButton = "MicroButtonsMover",
		SocialsMicroButton = "MicroButtonsMover",
		PVPMicroButton = "MicroButtonsMover",
		LFGMicroButton = "MicroButtonsMover",
		WorldMapMicroButton = "MicroButtonsMover",
		MainMenuMicroButton = "MicroButtonsMover",
		HelpMicroButton = "MicroButtonsMover",
		
		PetActionButton1 = "PetActionButtonsMover",
		PetActionButton2 = "PetActionButtonsMover",
		PetActionButton3 = "PetActionButtonsMover",
		PetActionButton4 = "PetActionButtonsMover",
		PetActionButton5 = "PetActionButtonsMover",
		PetActionButton6 = "PetActionButtonsMover",
		PetActionButton7 = "PetActionButtonsMover",
		PetActionButton8 = "PetActionButtonsMover",
		PetActionButton9 = "PetActionButtonsMover",
		PetActionButton10 = "PetActionButtonsMover",
	},
	lHideOnScale = {
		MainMenuExpBar = {
			MainMenuXPBarTexture0,
			MainMenuXPBarTexture1,
			MainMenuXPBarTexture2,
			MainMenuXPBarTexture3,
			ExhaustionTick,
			ExhaustionTickNormal,
			ExhaustionTickHighlight,
			ExhaustionLevelFillBar,
		}
	},
	lLinkedScaling = {
	},
	nextFrameIdx = 1,
	pendingFrames = {},
	
	MOVEATONETIME = 20,
	SCROLL_HEIGHT = 45,
	CurrentMover = 1,
	NoScale = {
		TooltipMover = true,
		FramerateMover = true,
		WorldStateAlwaysUpFrame = true,
		MainMenuBarArtFrame = true,
		
		MainMenuBarLeftEndCap = true,
		MainMenuBarRightEndCap = true,
		
		ReputationWatchBar = true,
	},
	ScaleWH = {
		MainMenuExpBar = true,
	},
	DetachFromParent = {
		MainMenuBarPerformanceBarFrame = true,
		TargetofFocusFrame = true,
		PetFrame = true,
		PartyMemberFrame1PetFrame = true,
		PartyMemberFrame2PetFrame = true,
		PartyMemberFrame3PetFrame = true,
		PartyMemberFrame4PetFrame = true,
		DebuffButton1 = true,
		ReputationWatchBar = true,
		MainMenuExpBar = true,
		TimeManagerClockButton = true,
	},
	NoHide = {},
	HideList = {
		MAOptions = {
			{ "MAOptions", "ARTWORK","BORDER"},
		},
		GameMenuFrame = {
			{ "GameMenuFrame", "BACKGROUND","ARTWORK","BORDER"},
		},
		MainMenuBar = {
			{ "MainMenuBarArtFrame", "BACKGROUND","ARTWORK"},
			{ "PetActionBarFrame", "OVERLAY"},
			{ "ShapeshiftBarFrame", "OVERLAY"},
			{ "MainMenuBar", "DISABLEMOUSE"},
			{ "BonusActionBarFrame", "OVERLAY", "DISABLEMOUSE"},
			{ "MainMenuBarLeftEndCap", "FRAME"},
			{ "MainMenuBarRightEndCap", "FRAME"},
		},
		MainMenuExpBar = {
			{ "MainMenuExpBar", "WH", "BORDER", "OVERLAY"},
			{ "ExhaustionTick", "FRAME"},
			{ "MainMenuExpBar", function( show )
					if MovAny:SafeToMove() then	
						if( show ) then
							MovAny:AllowExternalVisibility( MainMenuExpBar.TextString );
						else
							MovAny:PreventExternalVisibility( MainMenuExpBar.TextString );
						end
					end
				end		
			},
		},
	},
	HideUsingWH = {
		MainMenuExpBar = true,
	},
	MoveOnlyWhenVisible = {
		WorldStateCaptureBar1 = true,
		AlwaysUpFrame1 = true,
		AlwaysUpFrame2 = true,
	},
	NoMove = {
		MinimapBorderTop = true,
		MainMenuBarPageNumber = true,
	},
	DefaultFrameList = {
		{ "", "Player" },
		{ "PlayerFrame", "Player" },
		{ "BuffFrame", "Buffs" },
		{ "TemporaryEnchantFrame", "Item buffs & Debuffs" },
		
		{ "", "Target" },
		{ "TargetFrame", "Target" },
		{ "TargetFrameSpellBar", "Casting Bar" },
		{ "TargetofTargetFrame", "Target of Target" },
		{ "TargetofTargetFrameDebuff1", "Target of Target Debuffs" },
		
		{ "", "Focus" },
		{ "FocusFrame", "Focus" },
		{ "FocusFrameDebuff1", "Debuffs" },
		{ "TargetofFocusFrame", "Target of Focus" },
		{ "TargetofFocusFrameDebuff1", "Target of Focus Debuffs" },
		
		{ "", "Party" },
		{ "PartyMemberFrame1", "Party Member 1" },
		{ "PartyMemberFrame1Debuff1", "Party Member 1 Debuffs" },
		{ "PartyMemberFrame2", "Party Member 2" },
		{ "PartyMemberFrame2Debuff1", "Party Member 2 Debuffs" },
		{ "PartyMemberFrame3", "Party Member 3" },
		{ "PartyMemberFrame3Debuff1", "Party Member 3 Debuffs" },
		{ "PartyMemberFrame4", "Party Member 4" },
		{ "PartyMemberFrame4Debuff1", "Party Member 4 Debuffs" },
		{ "PartyMemberBackground", "Party Background" },
		
		{ "", "Pets" },
		{ "PetFrame", "Pet" },
		{ "PartyMemberFrame1PetFrame", "Party Pet 1" },
		{ "PartyMemberFrame2PetFrame", "Party Pet 2" },
		{ "PartyMemberFrame3PetFrame", "Party Pet 3" },
		{ "PartyMemberFrame4PetFrame", "Party Pet 4" },
		
		{ "", "Bags" },
		{ "BagButtonsMover", "Bag Buttons" },
		{ "BagButtonsVerticalMover", "Bag Buttons (Vertical)" },
		{ "BagFrame1", "Backpack" },
		{ "BagFrame2", "Bag 1" },
		{ "BagFrame3", "Bag 2" },
		{ "BagFrame4", "Bag 3" },
		{ "BagFrame5", "Bag 4" },
		{ "KeyRingFrame", "Key Ring" },
		
		{ "", "Bank" },
		{ "BankFrame", "Bank" },
		{ "BankBagFrame1", "Bank Bag 1" },
		{ "BankBagFrame2", "Bank Bag 2" },
		{ "BankBagFrame3", "Bank Bag 3" },
		{ "BankBagFrame4", "Bank Bag 4" },
		{ "BankBagFrame5", "Bank Bag 5" },
		{ "BankBagFrame6", "Bank Bag 6" },
		{ "BankBagFrame7", "Bank Bag 7" },
		
		{ "", "Minimap" },
		{ "MinimapCluster", "MiniMap" },
		{ "MinimapZoneTextButton", "Zone Text" },
		{ "MinimapToggleButton", "Toggler (X)" },
		{ "MinimapBorderTop", "Top Border" },
		{ "MinimapZoomIn", "Zoom In" },
		{ "MinimapZoomOut", "Zoom Out" },
		{ "MiniMapMailFrame", "Mail Notification" },
		{ "MiniMapTracking", "Tracking" },
		{ "MiniMapBattlefieldFrame", "Battlegrounds" },
		{ "MiniMapWorldMapButton", "Map" },
		{ "GameTimeFrame", "Calendar" },
		{ "TimeManagerClockButton", "Clock" },
		
		{ "", "Bottom Bar" },
		{ "MainMenuBar", "Bottom Bar" },
		{ "ShapeshiftBarFrame", "Shapeshift Bar Frame" },
		{ "PossessBarFrame", "Possess Bar Frame" },
		{ "MainMenuBarLeftEndCap", "Left Gryphon" },
		{ "MainMenuBarRightEndCap", "Right Gryphon" },
		{ "MainMenuExpBar", "Experience Bar" },
		{ "MainMenuBarMaxLevelBar", "Experience Bar (Max Level Bar)" },
		{ "ReputationWatchBar", "Reputation Tracker Bar" },
		{ "KeyRingButton", "Key Ring Button" },
		
		{ "", "Action Button Bar" },
		{ "BasicActionButtonsMover", "Action Buttons" },
		{ "BasicActionButtonsVerticalMover", "Action Buttons (Vertical)" },
		{ "MainMenuBarPageNumber", "Action Bar Page Number" },
		{ "ActionBarUpButton", "Action Bar Page Up" },
		{ "ActionBarDownButton", "Action Bar Page Down" },
		{ "PetActionButtonsMover", "Pet Action Buttons" },
		{ "PetActionButtonsVerticalMover", "Pet Action Buttons (Vertical)" },
		{ "ShapeshiftButtonsMover", "Stance / Aura / Shapeshift Buttons" },
		{ "ShapeshiftButtonsVerticalMover", "Stance / Aura / Shapeshift (Vertical)" },
		
		{ "", "Micro Menu Bar" },
		{ "MicroButtonsMover", "Micro Menu" },
		{ "MicroButtonsVerticalMover", "Micro Menu (Vertical)" },
		
		{ "", "Extra Action Bars" },
		{ "MultiBarBottomLeft", "Bottom Left ActionBar" },
		{ "MultiBarBottomRight", "Bottom Right ActionBar" },
		{ "MultiBarRight", "Right ActionBar" },
		{ "MultiBarLeft", "Right ActionBar 2" },
		
		{ "", "Quests" },
		{ "QuestLogFrame", "Quest Log" },
		{ "QuestFrame", "Quest Details" },
		{ "WatchFrame", "Quest Tracker" },
		{ "QuestTimerFrame", "Quest Timer" },
		
		{ "", "Guild" },
		{ "GuildInfoFrame", "Guild Info" },
		{ "GuildMemberDetailFrame", "Guild Member Details" },
		{ "GuildControlPopupFrame", "Guild Control" },
		{ "GuildRegistrarFrame", "Guild Registrar" },
		{ "GuildBankFrame", "Guild Bank" },
		
		{ "", "Battlegrounds & PvP" },
		{ "PVPFrame", "PVP Window" },
		{ "PVPTeamDetails", "Arena Team Details" },
		{ "ArenaFrame", "Arena Queue List" },
		{ "ArenaRegistrarFrame", "Arena Registrar" },
		{ "PVPBannerFrame", "Arena Banner" },
		{ "BattlefieldMinimap", "Battlefield Minimap" },
		{ "BattlefieldFrame", "Battleground Queue" },
		{ "WorldStateScoreFrame", "Battleground Score" },
		{ "WorldStateAlwaysUpFrame", "Flags Frame" },
		{ "AlwaysUpFrame1", "Alliance Flag" },
		{ "AlwaysUpFrame2", "Horde Flag" },
		{ "WorldStateCaptureBar1", "Flag Capture Timer Bar" },
		
		{ "", "Loot" },
		{ "LootFrame", "Loot" },
		{ "GroupLootFrame1", "Loot Roll 1" },
		{ "GroupLootFrame2", "Loot Roll 2" },
		{ "GroupLootFrame3", "Loot Roll 3" },
		{ "GroupLootFrame4", "Loot Roll 4" },
		
		{ "", "Miscellaneous Screen Items" },
		{ "TimeManagerFrame", "Alarm Clock" },
		{ "MirrorTimer1", "Breath/Fatigue Bar" },
		{ "CastingBarFrame", "Casting Bar" },
		{ "ComboFrame", "Combo points" },
		{ "DurabilityFrame", "Durability" },
		{ "FramerateMover", "Framerate" },
		{ "ItemSocketingFrame", "Gem Socketing" },
		{ "ScriptErrors", "Script Errors" },
		{ "TicketStatusFrame", "Ticket Status" },
		{ "TooltipMover", "Tooltip" },
		{ "TutorialFrame", "Tutorial Frame" },
		{ "ZoneTextFrame", "Zone Zoning Text" },
		{ "SubZoneTextFrame", "Subzone Zoning Text" },
		{ "ReputationDetailFrame", "Reputation Details" },
		{ "UIErrorsFrame", "UI Errors Frame" },
		{ "VoiceChatTalkers", "Voice Chat Talkers" },
		
		{ "", "Miscellaneous Windows" },
		{ "AuctionFrame", "Auction House" },
		{ "BarberShopFrame", "Barber Shop" },
		{ "CalendarFrame", "Calendar" },
		{ "HelpFrame", "GM Help" },
		
		{ "", "Achievements" },
		{ "AchievementFrame", "Achievements" },
		{ "AchievementWatchFrame", "Achievements Tracker" },
		{ "AchievementAlertFrame1", "Achievement Alert 1" },
		{ "AchievementAlertFrame2", "Achievement Alert 2" },
		
		{ "", "Popups" },
		{ "StaticPopup1", "Static Popup 1" },
		{ "StaticPopup2", "Static Popup 2" },
		{ "StaticPopup3", "Static Popup 3" },
		{ "StaticPopup4", "Static Popup 4" },
		{ "StationeryPopupFrame", "StationeryPopupFrame" },
		
		{ "", "Info Panels" },
		{ "UIPanelMover1", "Generic Info Panel 1" },
		{ "UIPanelMover2", "Generic Info Panel 2" },
		{ "CharacterFrame", "Character / Pet / Reputation / Skills" },
		{ "TaxiFrame", "Flight Path" },
		{ "FriendsFrame", "Friends / Who / Guild / Chat / Raid" },
		{ "GossipFrame", "Gossip" },
		{ "InspectFrame", "Inspect" },
		{ "LFGParentFrame", "LFG/M" },
		{ "MacroFrame", "Macros" },
		{ "MailFrame", "Mailbox" },
		{ "MerchantFrame", "Merchant" },
		{ "OpenMailFrame", "Open Mail" },
		{ "PetStableFrame", "Pet Stable" },
		{ "SpellBookFrame", "Spell Book" },
		{ "TabardFrame", "Tabard Design" },
		{ "PlayerTalentFrame", "Talents" },
		{ "TradeFrame", "Trade" },
		{ "TradeSkillFrame", "Trade Skills" },
		{ "ClassTrainerFrame", "Trainer" },
		{ "DressUpFrame", "Wardrobe" },
		
		{ "", "Game Menu" },
		{ "GameMenuFrame", "Game Menu" },
		{ "VideoOptionsFrame", "Video Options" },
		{ "AudioOptionsFrame", "Sound & Voice Options"},
		{ "InterfaceOptionsFrame", "Interface Options"},
		{ "KeyBindingFrame", "Keybinding Options" },
		
		{ "", "MoveAnything!" },
		{ "MAOptions", "MA! Window" },
		{ "MANudger", "MA! Nudger" },
		{ "GameMenuButtonMoveAnything", "MA! Game Menu Button" },
		
		{ "", "Custom Windows" },
	},
	
	
----------------------------------------------------------------
--X: hooks

	ContainerFrame_GenerateFrame = function (frame, size, id)
		MovAny:GrabContainerFrame(frame, MovAny:GetBag(id))
	end,
	
	ContainerFrame_OnHide = function ()
		--[[
		local bag = MovAny:GetBag(this:GetID())
		if bag and MovAny:IsFrameHooked(bag:GetName()) then
			MovAny:AllowExternalMovement( this )
			if this.MAContainerOriginalScale and this.MAContainerOriginalScale > 0 then
				this:SetScale(this.MAContainerOriginalScale)
				this.MAContainerOriginalScale = nil
			end
			this:ClearAllPoints()
			-- we removed the container from the list before, but now we have to add
			-- it back, since the container code is going to try to remove it, and doesn't
			-- particularly care if it's already gone
			--ContainerFrame1.bagsShown = ContainerFrame1.bagsShown + 1
			--ContainerFrame1.bags[ ContainerFrame1.bagsShown ] = this:GetName()
			
		end
		]]--
	end,
	
	ContainerFrame_OnShow = function (frame)
		local bag = MovAny:GetBag(frame:GetID())
		if bag and MovAny:IsFrameHooked(bag:GetName()) then
			--updateContainerFrameAnchors()
		end
	end,
	
	CloseAllWindows = function ()
		for i, v in pairs(MovAny.frames) do
			if MovAny:IsFrameHooked( v.name ) then
				
				local opt = MovAny:GetFrameOptions( v.name)
				if opt and opt.UIPanelWindows then
					local f = getglobal(v.name)
					if ( f ~= nil ) then
						if( f:IsShown() ) then
							f:Hide()
						end
					end
				end
			end
		end
	end,
	
	ShowUIPanel = function (frame)
		if MovAny:SafeToMove() then
			MovAny:SetLeftFrameLocation()
			MovAny:SetCenterFrameLocation()
		end
	end,
	
	HideUIPanel = function (frame)
		if MovAny:SafeToMove() then
			MovAny:SetLeftFrameLocation()
			MovAny:SetCenterFrameLocation()
		end
	end,
	
	GameTooltip_SetDefaultAnchor = function (tooltip, parent)
		if tooltip == GameTooltip and MovAny:IsFrameHooked("TooltipMover") then
			-- anchor the tooltip to the side of the mover that is closest to the edge
			local l, r, t, b, a, anchor
			l = TooltipMover:GetLeft() - UIParent:GetLeft()
			r = UIParent:GetRight() - TooltipMover:GetRight()
			t = UIParent:GetTop() - TooltipMover:GetTop()
			b = TooltipMover:GetBottom() - UIParent:GetBottom()
			a = t
			anchor = "TOP"
			if( l < a ) then
				a = l
				anchor = "LEFT"
			end
			if( r < a ) then
				a = r
				anchor = "RIGHT"
			end
			if( b < a ) then
				a = b
				anchor = "BOTTOM"
			end
	
			tooltip:ClearAllPoints()
			tooltip:SetOwner(parent, "ANCHOR_NONE")
			tooltip:SetPoint(anchor, "TooltipMover", anchor, 0, 0)
			tooltip.default = 1
		end
	end,
	
	UpdateTalentButton = function (...)
		if MovAny:IsFrameHooked("MicroButtonsVerticalMover") then
			if UnitLevel("player") < 10 then
				AchievementMicroButton:SetPoint("TOPLEFT", "TalentMicroButton", "TOPLEFT", 0, 0)
			else
				AchievementMicroButton:SetPoint("TOPLEFT", "TalentMicroButton", "BOTTOMLEFT", 0, 24)
			end
		end
	end,
	
	UIParent_ManageFramePositions = function()
		if NUM_EXTENDED_UI_FRAMES then
			local opts = MovAny:GetFrameOptions("WorldStateCaptureBar1")
			if not opts or not opts.movable then
				return
			end
			local lastBar = nil
			for i=1, NUM_EXTENDED_UI_FRAMES do
				local captureBar = getglobal("WorldStateCaptureBar"..i)
				if captureBar and captureBar:IsVisible() then
					captureBar:ClearAllPoints()
					if i==1 then
						captureBar:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", opts.x, opts.y)
					else
						captureBar:SetPoint("TOPLEFT", lastBar, "TOPLEFT", 0, -25)
					end
					lastBar = captureBar
				end
			end
		end
	end,
	
	CaptureBar_Create = function(id)
		local frame= MovAny.oCaptureBar_Create(id)
		frame:EnableMouse(true)
		local opts = MovAny:GetFrameOptions("WorldStateCaptureBar1")
		if opts then
			if opts.movable then
				frame:ClearAllPoints()
				frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", opts.x, opts.y)
			end
			MovAny:SafeScale(frame, opts)
			if opts.alpha then
				frame:SetAlpha(opts.alpha)
			end
			if frame.hidden then
				return
			end
		end
		return frame
	end,
	
	AchievementAlertFrame_OnLoad = function(self)
		MovAny.oAchievementAlertFrame_OnLoad(self)
		local opts = MovAny:GetFrameOptions(self:GetName())
		if opts then
			if opts.movable then
				self:ClearAllPoints()
				self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", opts.x, opts.y)
			end
			MovAny:SafeScale(self, opts)
		end
	end,
	
	AchievementAlertFrame_GetAlertFrame = function()
		local frame = MovAny.oAchievementAlertFrame_GetAlertFrame()
		local opts = MovAny:GetFrameOptions(frame:GetName())
		if opts then
			if opts.movable then
				frame:ClearAllPoints()
				frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", opts.x, opts.y)
			end
			MovAny:SafeScale(frame, opts)
			if opts.alpha then
				frame:SetAlpha(opts.alpha)
			end
			if frame.hidden then
				return
			end
		end
		return frame
	end,
----------------------------------------------------------------
};

BINDING_HEADER_MOVEANYTHING = "MoveAnything!"
MA_LEFTARROW = "<"
MA_RIGHTARROW = ">"

MoveAnything_CustomFrames = {}
MoveAnything_CharacterSettings = {}
MoveAnything_UseCharacterSettings = false

StaticPopupDialogs["MOVEANYTHING_RESET_CONFIRM"] = {
	text = "MoveAnything: Reset all frames?",
	button1 = TEXT(YES),
	button2 = TEXT(NO),
	OnAccept = function()
		MovAny:ResetAll()
	end,
	timeout = 0,
	exclusive = 0,
	showAlert = 1,
	whileDead = 1,
	hideOnEscape = 1
}

function MovAny:Boot()
	if self.initRun then
		return
	end
	
	local autoShowUI = false
	if MoveAnything_CharacterSettings == nil then
		autoShowUI = true
	end
	
	MAOptionsToggleCategories:SetChecked(MADB.collapsed)
	
	-- add default frames to list
	local sepLast = nil -- used later as it points to the Custom frames heading
	local sepItems = 0
	for i, v in pairs(self.DefaultFrameList) do
		if v[1]  then
			if v[1] == "" then
				if sepLast then
					sepLast.items = sepItems
				end
				sepItems = 0
				
				local sep = {}
				sep.idx = self.nextFrameIdx
				self.nextFrameIdx = self.nextFrameIdx + 1
				sep.name = nil
				sep.helpfulName = v[2]
				sep.sep = true
				sep.collapsed = MADB.collapsed
				sep.items = 0
				table.insert(self.frames, sep)
				table.insert(self.cats, sep)
				self.framesCount = self.framesCount + 1
				sepLast = sep
			else
				self:AddFrameToMovableList(v[1], v[2], 2)
				sepItems = sepItems + 1
				if sepLast then
					self.frames[ self.nextFrameIdx - 1 ].cat = sepLast
				end
			end
		end
	end
	self.DefaultFrameList = nil
	
	local settingsName = self:GetSettingsName()
	if MoveAnything_CharacterSettings[settingsName] == nil then
		MoveAnything_CharacterSettings[settingsName] = {}
	end
	self.FrameOptions = MoveAnything_CharacterSettings[settingsName]
	
	self:VerifyData()
	
	table.sort(MoveAnything_CustomFrames, function(o1,o2)
		return o1.name:lower() < o2.name:lower()
	end)
	
	for i, v in pairs(MoveAnything_CustomFrames) do
		if not self:GetFrame( v.name ) then
			self:AddFrameToMovableList(v.name, v.helpfulName, 1)
			sepLast.items = sepLast.items + 1
		end
	end

	self.initRun = true
	
	hooksecurefunc("ContainerFrame_GenerateFrame", self.ContainerFrame_GenerateFrame)
	--hooksecurefunc("ContainerFrame_OnHide", self.ContainerFrame_OnHide)
	--hooksecurefunc("ContainerFrame_OnShow", self.ContainerFrame_OnShow)
	hooksecurefunc("CloseAllWindows", self.CloseAllWindows)
	hooksecurefunc("ShowUIPanel", self.ShowUIPanel)
	hooksecurefunc("HideUIPanel", self.HideUIPanel)
	hooksecurefunc("GameTooltip_SetDefaultAnchor", self.GameTooltip_SetDefaultAnchor)
	hooksecurefunc("UpdateTalentButton", self.UpdateTalentButton)
	hooksecurefunc("UIParent_ManageFramePositions", self.UIParent_ManageFramePositions)
	
	self.oUpdateContainerFrameAnchors = updateContainerFrameAnchors
	updateContainerFrameAnchors = self.UpdateContainerFrameAnchors
	
	self.oCaptureBar_Create = ExtendedUI.CAPTUREPOINT.create
	ExtendedUI.CAPTUREPOINT.create = self.CaptureBar_Create
	
	self.oAchievementAlertFrame_OnLoad = AchievementAlertFrame_OnLoad
	AchievementAlertFrame_OnLoad = self.AchievementAlertFrame_OnLoad
	
	self.oAchievementAlertFrame_GetAlertFrame = AchievementAlertFrame_GetAlertFrame
	AchievementAlertFrame_GetAlertFrame = self.AchievementAlertFrame_GetAlertFrame
	
	--[[
	for i,v in pairs(self.lEnableMouse) do
		if v and v.EnableMouse then
			v:EnableMouse(true)
		end
	end
	]]
	self.lEnableMouse = nil
	
	self.pendingFrames = deepcopy(self.FrameOptions)
	
	self:InitPositions()
	
	getglobal("MAOptionsCaption"):SetText("MoveAnything! "..GetAddOnMetadata("MoveAnything", "Version"))
	
	if autoShowUI then
		MAOptions:Show()
	end
end

function MovAny:OnPlayerLogout()
	for i, v in pairs(MoveAnything_CustomFrames) do
		v.idx = nil
	end
end

function MovAny:VerifyData()
	local cleanse = {}
	for i, opt in pairs(self.FrameOptions) do
		while 1 do
			if not opt or opt == nil then
				break
			end
			
			if not self.defFrames[ opt.name ] then
				self:AddCustomFrameIfNew(opt.name)
			end
			break
		end
	end
	
	for i, v in pairs(cleanse) do
		self:ClearFrameOptions(v)
	end
end

function MovAny:AddCustomFrameIfNew(name)
	local found = nil
	for i in pairs(MoveAnything_CustomFrames) do
		if MoveAnything_CustomFrames[i].name == name then
			found = i
			break
		end
	end
	if found == nil then
		table.insert(MoveAnything_CustomFrames, { name = name, helpfulName = name})
		return true
	end
	return false
end

function MovAny:ErrorNotInCombat( silent, msg )
	if UnitAffectingCombat("player") then
		if not silent then
			maPrint("Disabled during combat", msg)
		end
		return true
	end
	return false
end

function MovAny:SafeScale( f, opts )
	if self.NoScale[ f:GetName() ] then
		return
	elseif self.ScaleWH[ f:GetName() ] then
		if f:GetWidth() ~= opts.width or f:GetHeight() ~= opts.height then
			f:SetWidth(opts.width)
			f:SetHeight(opts.height)
			if self.lHideOnScale[ f:GetName() ] then
				for i,v in pairs(self.lHideOnScale[ f:GetName() ]) do
					v:Hide()
				end
			end
			
			if self.lLinkedScaling[ f:GetName() ] then
				for i,v in pairs(self.lLinkedScaling[ f:GetName() ]) do
					v:SetWidth(opts.width)
					v:SetHeight(opts.height)
				end
			end
		end
	elseif opts.scale and opts.scale > 0 and self:IsScalableFrame(f) and opts.scale ~= f:GetScale() then
		if type(f.HiddenSetScale) == "function" then
			f:HiddenSetScale(opts.scale)
		else
			f:SetScale(opts.scale)
		end
		
		if self.lHideOnScale[ f ] then
			for i,v in pairs(self.lHideOnScale[ f ]) do
				v:Hide()
			end
		end
		
		if f.attachedChildren then
			for i, v in pairs(f.attachedChildren) do
				self:SafeScale(v, opts)
			end
		end
		if self.lLinkedScaling[ f:GetName() ] then
			for i,v in pairs(self.lLinkedScaling[ f:GetName() ]) do
				self:SafeScale(v, opts)
			end
		end
	end
end

function MovAny:ToggleVisibilityOnFrame(frame)
	if not frame then
		return;
	end
	local opt = self:GetFrameOptions( frame:GetName() );
	if opt and opt.hidden == true then
		self:ShowFrame(frame)
	else
		self:HideFrame(frame)
	end
end

function MovAny:IsScalableFrame( frameName )
	if self.NoScale[ frameName ] or self.ScaleWH[ frameName ] then
		return false
	end
	return true
end

function MovAny:InitPositions()
	if not self.initRun then
		return
	end
	
	local frame, parent
	for k, opt in pairs(self.pendingFrames) do
		frame = getglobal(opt.name)
		if frame then
			if opt.movable or opt.hidden or opt.scale or opt.alhpa then
				self:HookFrame(opt.name, frame)
			end
			if opt.movable then
				if self.DetachFromParent[ opt.name ] then
					parent = UIParent
				else
					parent = MAGetParent(frame)
				end
				frame:HiddenClearAllPoints()
				frame:HiddenSetPoint("BOTTOMLEFT", parent:GetName(), "BOTTOMLEFT", opt.x, opt.y)
			end

			MovAny:SafeScale(frame, opt)
			
			if opt.alpha and opt.alpha ~= frame:GetAlpha() then
				frame:SetAlpha(opt.alpha)
			end
			if opt.hidden then
				self:HideFrame(frame)
			end
			self.pendingFrames[k] = nil
		end
	end
end

function MovAny:RefreshPositions()
	if not self.initRun or not self:SafeToMove() then
		return;
	end
	
	local frame, parent;
	for k, opt in pairs(self.FrameOptions) do
		if self.runBeforeMove[opt.name] then
			self.runBeforeMove[opt.name]()
		end
		frame = getglobal(opt.name)
		if frame then
			if opt.movable or opt.hidden or opt.scale or opt.alhpa then
				self:HookFrame(opt.name, frame)
			end
			if opt.movable then
				if self.DetachFromParent[ opt.name ] then
					parent = UIParent
				else
					parent = MAGetParent(frame)
				end
				frame:HiddenClearAllPoints()
				frame:HiddenSetPoint("BOTTOMLEFT", parent:GetName(), "BOTTOMLEFT", opt.x, opt.y)
			end

			MovAny:SafeScale(frame, opt)
			
			if opt.alpha and opt.alpha ~= frame:GetAlpha() then
				frame:SetAlpha(opt.alpha)
			end
			if opt.hidden then
				self:HideFrame(frame)
			end
		end
	end
end

function MovAny:GetSettingsName(override)
	local val = MoveAnything_UseCharacterSettings
	if override ~= nil then
		val = override
	end
	if val then
		return GetCVar("realmName").." "..UnitName("player")
	else
		return "default"
	end
end

function MovAny:CopySettings( fromName, toName )
	if( MoveAnything_CharacterSettings[toName] == nil ) then
		MoveAnything_CharacterSettings[toName] = {};
	end
	for i, val in pairs(MoveAnything_CharacterSettings[fromName]) do
		MoveAnything_CharacterSettings[toName][i] = val;
	end
	self.FrameOptions = MoveAnything_CharacterSettings[self:GetSettingsName()];
	self:RefreshPositions();
end

function MovAny:GetFrameCount()
	return self.framesCount
end

function MovAny:ClearFrameOptions( frameName )
	self.FrameOptions[ frameName ] = nil
	self:RemoveIfCustom(frameName)
end

function MovAny:GetFrameOptions( frameName )
	if self.FrameOptions == nil then
		return nil
	end
	return self.FrameOptions[ frameName ]
end

function MovAny:GetFrame( frameName )
	for i,v in pairs(self.frames) do
		if v.name == frameName then
			return v
		end
	end
	return nil
end

function MovAny:RemoveIfCustom( frameName )
	local removed = false
	for i in pairs(MoveAnything_CustomFrames) do
		if MoveAnything_CustomFrames[i].name == frameName then
			table.remove(MoveAnything_CustomFrames, i)
			removed = true
			break
		end
	end
	
	if( removed ) then
		for i in pairs(self.frames) do
			if self.frames[i].name == frameName then
				table.remove(self.frames, i)
				self.framesCount = self.framesCount - 1
				break
			end
		end
	end
end

function MovAny:PreventExternalVisibility( frame )
	if self.lSimpleHide[ frame ] then
		frame:Hide()
		return
	end

	frame.maWasShown = frame:IsShown()
	frame:Hide()
	frame.HiddenShow = frame.Show
	frame.HiddenHide = frame.Hide
	frame.HiddenIsVisible = frame.IsVisible
	frame.Show = MovAny_HiddenShow
	frame.Hide = MovAny_HiddenHide
	frame.IsVisible = MovAny_HiddenIsVisible
	if frame.attachedChildren then
		for i, val in pairs(frame.attachedChildren) do
			self:PreventExternalVisibility(val)
		end
	end
end

function MovAny:AllowExternalVisibility( frame )
	if self.lSimpleHide[ frame ] then
		frame:Show()
		return
	end
	
	frame.Show = frame.HiddenShow;
	frame.Hide = frame.HiddenHide;
	frame.IsVisible = frame.HiddenIsVisible;
	frame.HiddenShow = nil;
	frame.HiddenHide = nil;
	frame.HiddenIsVisible = nil;
	if frame.maWasShown then
		frame.maWasShown = nil
		frame:Show()
	end
	if frame.attachedChildren then
		for i, val in pairs(frame.attachedChildren) do
			self:AllowExternalVisibility(val)
		end
	end
end

function MovAny:PreventExternalMovement( el )
	if el.HiddenSetPoint == nil then
		el.HiddenSetPoint = el.SetPoint
		el.SetPoint = void
	end
	if el.HiddenSetAllPoints == nil then
		el.HiddenSetAllPoints = el.SetAllPoints
		el.SetAllPoints = void
	end
	if el.HiddenClearAllPoints == nil then
		el.HiddenClearAllPoints = el.ClearAllPoints
		el.ClearAllPoints = void
	end
	if el:IsObjectType("frame") then
		if el.HiddenSetScale == nil then
			el.HiddenSetScale = el.SetScale
			el.SetScale = void
		end
	end
	if el.attachedChildren then
		for i, val in pairs(el.attachedChildren) do
			self:PreventExternalMovement(val)
		end
	end
end

function MovAny:AllowExternalMovement( el )
	if el.HiddenSetPoint then
		el.SetPoint = el.HiddenSetPoint
		el.HiddenSetPoint = nil
	end
	if el.HiddenSetAllPoints then
		el.SetAllPoints = el.HiddenSetAllPoints
		el.HiddenSetAllPoints = nil
	end
	if el.HiddenClearAllPoints then
		el.ClearAllPoints = el.HiddenClearAllPoints
		el.HiddenClearAllPoints = nil
	end
	if el.HiddenSetScale then
		el.SetScale = el.HiddenSetScale
		el.HiddenSetScale = nil
	end
	if el.attachedChildren then
		for i, val in pairs(el.attachedChildren) do
			self:AllowExternalMovement(val)
		end
	end
end

function MovAny:HookFrame( frameName, frame )
	if not frame then
		frame = getglobal( frameName )
	end

	if not self:IsFrameHooked( frameName ) then
		local opt = self:GetFrameOptions(frameName)
		if opt == nil then
			opt = {}
			self.FrameOptions[ frameName ] = opt
		end
		opt.name = frameName
		opt.originalLeft, opt.originalBottom = self:GetRelativeBottomLeft(frame)
		if self.ScaleWH[ frameName ] then
			opt.originalWidth = frame:GetWidth()
			opt.originalHeight = frame:GetHeight()
			opt.originalScale = nil
		else
			opt.originalWidth = nil
			opt.originalHeight = nil
			opt.originalScale = MAGetScale( frame )
		end
	end
	
	if UIPanelWindows[frameName] then
		local left = GetUIPanel("left")
		local center = GetUIPanel("center")

		if frame == left then
			UIParent.left = nil
			if( center ) then
				MovAny:SetLeftFrameLocation()
			end
		elseif frame == center and left then
			UIParent.center = nil
		end
		local opt = self:GetFrameOptions(frameName)
		if opt then
			opt.UIPanelWindows = UIPanelWindows[ frameName ]
		end
		UIPanelWindows[ frameName ] = nil
	end
	if frame.OnMoveAnythingHook then
		frame.OnMoveAnythingHook(frame)
	end
	self:PreventExternalMovement(frame)
end

function MovAny:IsFrameHooked( frameName )
	if( frameName == nil ) then return; end
	local opt = self:GetFrameOptions( frameName );
	if( opt ) then
		if( opt.movable or opt.hidden ) then
			return true;
		end
	end
	return false;
end

function MovAny:IsFrameHidden( frameName )
	if frameName == nil then
		return
	end
	local opt = self:GetFrameOptions(frameName)
	if opt and opt.hidden then
		return true
	end
	return false
end

function MovAny:AddFrameToMovableList( frameName, helpfulName, default )
	if not self:GetFrame(frameName) then
		local frame = getglobal(frameName)
		local opts = {}
		opts.name = frameName
		opts.helpfulName = helpfulName
		if opts.helpfulName == nil then
			opts.helpfulName = opts.name
		end
		
		opts.idx = self.nextFrameIdx
		self.nextFrameIdx = self.nextFrameIdx + 1
		
		table.insert(self.frames, opts)
		self.framesCount = self.framesCount + 1
		
		if default == 2 then
			opts.default = true
			self.defFrames[ opts.name ] = opts
		else
			if default ~= 1 then
				table.insert(MoveAnything_CustomFrames, opts)
			end
		end
		self:UpdateGUIIfShown()
	end
end

function MovAny:Move(moveFrameName, helpfulName)
	if self:IsMAFrame(moveFrameName) then
		return
	end
	
	if self.MoveOnlyWhenVisible[ moveFrameName ] then
		local frame = getglobal(moveFrameName)
		if frame == nil or not frame:IsShown() then
			Error(moveFrameName.." can only be moved while visible.")
			return
		end
	end
	
	self.lastFrameName = moveFrameName
	
	if not self:GetMoverByFrameName(moveFrameName) then
		local frame = self:FindAvailableFrame()
		if frame == nil then
			Error("You can only move "..self.MOVEATONETIME.." frames at once.")
		else
			if self.runBeforeMove[moveFrameName] then
				self.runBeforeMove[moveFrameName]()
			end
			local created = false
			if self.createBeforeMove[moveFrameName] and not getglobal(moveFrameName) then
				CreateFrame("Frame", moveFrameName, UIParent, self.createBeforeMove[moveFrameName])
				created = true
			end
			if getglobal(moveFrameName) == nil then
				Error("\" Can't find "..moveFrameName.."\"")
			else
				local moveFrame = getglobal(moveFrameName)
				self:AddFrameToMovableList(moveFrameName, helpfulName)
				self:HookFrame(moveFrameName)
				self:AttachMover(frame,getglobal(moveFrameName))
				
				frame.createdTagged = created
				
				if moveFrame.OnMoveAnythingPostAttach then
					moveFrame.OnMoveAnythingPostAttach(moveFrame)
				end
				self:UpdateGUIIfShown()
			end
		end
	end
end

function MovAny:GetDefaultFrameParent(f)
	local c = f
	while c and c ~= UIParent do
		if c.GetName and c:GetName() then
			local m = string.match(c:GetName(),"^ContainerFrame[0-9]+")
			if m then
				local bag = self:GetBagInContainerFrame(getglobal(m))
				return getglobal(bag:GetName())
			end
			
			if self.defFrames[ c:GetName() ] then
				return getglobal(c:GetName())
			end
		end
		c = c:GetParent()
	end
	return nil
end

function MovAny:GetTopFrameParent(f)
	local c = f
	while c and c ~= UIParent do
		if c:IsToplevel() then
			return c
		end
		c = c:GetParent()
	end
	return nil
end

--X: binds
function MovAny:SafeMoveFrameAtCursor()
	if self:ErrorNotInCombat() then
		return
	end
	
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	
	while 1 == 1 do
		local transName = self:Translate(obj:GetName(), 1)
		if transName ~= obj:GetName() then
			self:ToggleMove(transName)
			break
		end
		
		local objTest = self:GetDefaultFrameParent(obj)
		if objTest then
			self:ToggleMove(objTest:GetName())
			break
		end
		
		objTest = self:GetTopFrameParent(obj)
		if objTest then
			self:ToggleMove(objTest:GetName())
			break
		end
		
		if obj and obj ~= WorldFrame and obj ~= UIParent and obj.GetName then
			self:ToggleMove(obj:GetName())
		end
		break
	end
	
	self:UpdateGUIIfShown()
end

function MovAny:MoveFrameAtCursor()
	if self:ErrorNotInCombat() then
		return
	end
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	if obj and obj ~= WorldFrame and obj ~= UIParent and obj:GetName() then
		self:ToggleMove(obj:GetName())
	end
	self:UpdateGUIIfShown()
end

function MovAny:SafeHideFrameAtCursor()
	if self:ErrorNotInCombat() then
		return
	end
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	
	while 1 do
		local transName = self:Translate(obj:GetName(), 1)
		if transName ~= obj:GetName() then
			--maPrint("Hiding "..transName)
			self:HideFrame(getglobal(transName))
			break
		end
		local objTest = self:GetDefaultFrameParent(obj)
		if objTest then
			--maPrint("Hiding "..objTest:GetName())
			self:HideFrame(objTest)
			break
		end
		objTest = self:GetTopFrameParent(obj)
		if objTest then
			--maPrint("Hiding "..objTest:GetName())
			self:AddFrameToMovableList(objTest:GetName(), nil);
			self:HideFrame(objTest)
			break
		end
		if obj and obj ~= WorldFrame and obj ~= UIParent then
			--maPrint("Hiding "..obj:GetName())
			self:AddFrameToMovableList(obj:GetName(), nil);
			self:HideFrame(obj)
			break
		end
		break
	end
	self:UpdateGUIIfShown()
end

function MovAny:HideFrameAtCursor()
	if self:ErrorNotInCombat() then
		return
	end
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	if obj and obj ~= WorldFrame and obj ~= UIParent then
		self:HideFrame(obj)
	end
	self:UpdateGUIIfShown()
end

function MovAny:SafeResetFrameAtCursor()
	if self:ErrorNotInCombat() then
		return
	end
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	
	while 1 do
		local transName = self:Translate(obj:GetName(), 1)
		if transName ~= obj:GetName() and self.FrameOptions[ obj:GetName() ] then
			--maPrint("Resetting "..obj:GetName())
			self:ResetFrameOptions(obj:GetName())
			break
		end
		local objTest = self:GetDefaultFrameParent(obj)
		if objTest and self.FrameOptions[ objTest:GetName() ] then
			--maPrint("Resetting "..objTest:GetName())
			self:ResetFrameOptions(objTest:GetName())
			break
		end
		objTest = self:GetTopFrameParent(obj)
		if objTest and self.FrameOptions[ objTest:GetName() ] then
			self:AddFrameToMovableList(objTest:GetName(), nil);
			--maPrint("Resetting "..objTest:GetName())
			self:ResetFrameOptions(objTest:GetName())
			break
		end
		if obj and obj ~= WorldFrame and obj ~= UIParent and self.FrameOptions[ obj:GetName() ] then
			self:AddFrameToMovableList(obj:GetName(), nil);
			--maPrint("Resetting "..obj:GetName())
			self:ResetFrameOptions(obj:GetName())
			break
		end
		break
	end
	self:UpdateGUIIfShown()
end


function MovAny:ResetFrameAtCursor()
	if self:ErrorNotInCombat() then
		return
	end
	local obj = GetMouseFocus()
	if self:IsMAFrame(obj:GetName()) then
		if self:IsMover(obj:GetName()) and obj.tagged then
			obj = obj.tagged;
		else
			return
		end
	end
	
	local frameName = obj:GetName()
	
	if self.FrameOptions[ frameName ] then
		maPrint("Resetting "..frameName)
		self:ResetFrameOptions(frameName)
	end
	self:UpdateGUIIfShown()
end

function MovAny:UpdatePosition( moveFrame )
	local x, y, parent;
	x = nil;
	y = nil;
	parent = nil;
	if moveFrame.tagged  then
		if self.DetachFromParent[ moveFrame.tagged:GetName() ] then
			x = moveFrame.tagged:GetLeft();
			y = moveFrame.tagged:GetBottom();
			parent = UIParent;
		else
			x, y = self:GetRelativeBottomLeft(moveFrame.tagged);
			parent = MAGetParent(moveFrame.tagged);
		end
		local opt = self:GetFrameOptions(moveFrame.tagged:GetName());
		opt.x = x;
		opt.y = y;
		
		if moveFrame.startAlpha ~= moveFrame.tagged:GetAlpha() then
			opt.alpha = moveFrame.tagged:GetAlpha()
		end
	end
	return x, y, parent;
end

function MovAny:StopMoving( moveFrameName )
	local frame = self:GetMoverByFrameName(moveFrameName)
	if frame then
		self:Detach(frame)
		self:UpdateGUIIfShown()
	end
end

function MovAny:IsMover(frameName)
	if frameName ~= nil and string.match(frameName, "^MoveAnything[0-9][0-9]?$") ~= nil then
		return true
	else
		return false
	end
end

function MovAny:IsMAFrame(frameName)
	if frameName ~= nil and string.match(frameName, "^MoveAnything[0-9]+") ~= nil then
		return true
	else
		return false
	end
end

function MovAny:IsContainer(frameName)
	if string.match(frameName, "^ContainerFrame[0-9]+$") then
		return true
	end
	return false
end

function MovAny:Translate(f,secondary)
	if self.lTranslate[ f ] then
		return self.lTranslate[ f ]
	end
	
	if secondary and self.lTranslateSec[ f ] then
		return self.lTranslateSec[ f ]
	end
	
	if f == "last" then
		return MovAny.lastFrameName
	else
		return f
	end
end

function MovAny:ToggleMove( moveFrameName )
	if moveFrameName == nil then
		return
	end
	if self:IsMAFrame(moveFrameName) then
		return
	end
	
	if self:GetMoverByFrameName( moveFrameName ) then
		self:StopMoving( moveFrameName )
	else
		self:Move( moveFrameName )
	end
end

function MovAny:GetMoverByFrameName( moveFrameName )
	local frame;
	for i = 1, self.MOVEATONETIME, 1 do
		frame = getglobal( "MoveAnything"..i );
		if( type(frame) ~= "nil" and frame:IsShown() and frame.tagged == getglobal( moveFrameName ) ) then
			return frame;
		end
	end
	return nil;
end

function MovAny:FindAvailableFrame()
	local frame;
	for i = 1, self.MOVEATONETIME, 1 do
		frame = getglobal( "MoveAnything"..i );
		if( not( frame:IsShown() ) ) then
			return frame;
		end
	end
	return nil;
end

function MovAny:GetParentScaleRatio( frame )
	return MAGetScale( frame, 1 );
end

function MovAny:GetRelativeBottomLeft( tagFrame )
	x = tagFrame:GetLeft();
	if( x ) then
		x = x - MAGetParent( tagFrame ):GetLeft() * MAGetScale( MAGetParent( tagFrame ) ) / MAGetScale( tagFrame );
	end
	y = tagFrame:GetBottom();
	if( y ) then
		y = y - MAGetParent( tagFrame ):GetBottom() * MAGetScale( MAGetParent( tagFrame ) ) / MAGetScale( tagFrame );
	end
	return x,y;
end

function MovAny:AttachMover( moveFrame, tagFrame )
	if moveFrame.tagged then
		self:Detach(moveFrame)
	end

	local listOptions = self:GetFrame(tagFrame:GetName())
	local frameOptions = self:GetFrameOptions(tagFrame:GetName())
	frameOptions.movable = true
	moveFrame.helpfulName = listOptions.helpfulName

	if tagFrame.OnBeginMove then
		if not tagFrame:OnBeginMove() then
			self:Detach(moveFrame)
			return
		end
	end

	local x, y
	x = 0
	y = 0
	if( tagFrame:GetLeft() == nil ) then tagFrame:Show(); tagFrame:Hide(); end
	
	if tagFrame:GetLeft() ~= nil then
	
	x = tagFrame:GetLeft() * MAGetScale( tagFrame, 1 ) / UIParent:GetScale();
	x = x - MAGetParent( tagFrame ):GetLeft() * MAGetScale( MAGetParent( tagFrame ), 1 ) / UIParent:GetScale();
	
	y = tagFrame:GetBottom() * MAGetScale( tagFrame, 1 ) / UIParent:GetScale();
	y = y - MAGetParent( tagFrame ):GetBottom() * MAGetScale( MAGetParent( tagFrame ), 1 ) / UIParent:GetScale();
	
	end
	
	moveFrame:ClearAllPoints();
	moveFrame:SetPoint( "BOTTOMLEFT", MAGetParent( tagFrame ):GetName(), "BOTTOMLEFT", x, y );
	
	moveFrame:SetWidth( tagFrame:GetWidth() * MAGetScale( tagFrame , 1 ) / UIParent:GetScale() );
	moveFrame:SetHeight( tagFrame:GetHeight() * MAGetScale( tagFrame, 1 ) / UIParent:GetScale() );
	
	if tagFrame.GetFrameLevel then
		moveFrame:SetFrameLevel( tagFrame:GetFrameLevel() + 1 );
	end
	
	tagFrame:HiddenClearAllPoints();
	tagFrame:HiddenSetPoint( "BOTTOMLEFT", moveFrame:GetName(), "BOTTOMLEFT", 0, 0 );

	moveFrame.tagged = tagFrame;

	moveFrame:Show();
end

function MovAny:Detach( moveFrame )
	if( moveFrame.tagged ) then
		local x, y, parent = self:UpdatePosition( moveFrame );
		moveFrame.tagged:HiddenClearAllPoints();
		moveFrame.tagged:HiddenSetPoint( "BOTTOMLEFT", parent:GetName(), "BOTTOMLEFT", x, y );
		
		if moveFrame.createdTagged then
			moveFrame.tagged:Hide()
		end
	end
	moveFrame:Hide();
	moveFrame.tagged = nil;
end

function MovAny:ResetFrameOptions( frameName )
	if frameName==nil then
			return
	end
	self:StopMoving(frameName)
	
	local frame = getglobal(frameName)
	if not frame then
		self:ClearFrameOptions(frameName)
		self:UpdateGUIIfShown()
		return
	end
	
	local opt = self:GetFrameOptions(frameName)
	if frame.OnMoveAnythingPreReset then
		frame.OnMoveAnythingPreReset(frame)
	end
	
	local wasHidden = false
	local left = nil
	local bottom = nil
	local hidden = false
	local width = nil
	local height = nil
	local scale = nil
	local alpha = nil
	if opt then
		left = opt.originalLeft
		bottom = opt.originalBottom
		width = opt.originalWidth
		height = opt.originalHeight
		if opt.hidden then
			opt.hidden = nil
			wasHidden = true
		end
		scale = opt.originalScale
		alpha = opt.alpha
	end
	
	self:AllowExternalMovement(frame)
	
	if wasHidden then
			self:ShowFrame(frame)
	end
	
	if (left or bottom) then
		frame:ClearAllPoints()
		frame:SetPoint( "BOTTOMLEFT", MAGetParent( frame ):GetName(), "BOTTOMLEFT", left, bottom )
	end
		
	if scale and scale > 0 then
		self:SmartSetScale(frame, scale)
		if frame.attachedChildren then
			for i, v in pairs(frame.attachedChildren) do
				self:SmartSetScale(v,scale)
			end
		end
	end
	if alpha then
		frame:SetAlpha(1)
	end
	if width then
		frame:SetWidth(width)
	end
	if height then
		frame:SetHeight(height)
	end
	
	if frame.OnMoveAnythingPostReset then
		frame.OnMoveAnythingPostReset(frame)
	end

	frame.attachedChildren = nil
	if opt and opt.UIPanelWindows then
		UIPanelWindows[ frameName ] = opt.UIPanelWindows
		if frame:IsShown() then
			frame:Hide()
			ShowUIPanel(frame)
		end
	end
	
	self:ClearFrameOptions(frameName)
	self:UpdateGUIIfShown()
end

function MovAny:SmartSetScale(frame,scale)
	if not frame:IsObjectType("frame") or not self:IsScalableFrame(frame:GetName()) then
		return false
	end
	if frame:GetScale()~=scale then
		frame:SetScale(scale)
	end
	return true
end

function MovAny:SmartHiddenSetScale(frame,scale)
	if not frame:IsObjectType("frame") or not frame.HiddenSetScale or not self:IsScalableFrame(frame:GetName()) then
		return false
	end
	if frame:GetScale()~=scale then
		frame:HiddenSetScale(scale)
	end
	return true
end

function MovAny:ToggleOptionsMenu()
	if( MAOptions:IsShown() ) then
		MAOptions:Hide();
	else
		MAOptions:Show();
	end
end

function MovAny:GetMovableFrame( idx )
	return getglobal(self.frames[ idx ].name)
end

function MovAny:OnMoveCheck( button )
	local frameName = self.frames[ button:GetParent().idx ].name;
	
	if self:ErrorNotInCombat() then
		button:SetChecked(false)
		return
	end
	
	if( button:GetChecked() ) then
		self:Move( frameName );
	else
		self:StopMoving( frameName );
	end
	
	self:UpdateGUIIfShown()
end

function MovAny:OnHideCheck( button )
	if self:ErrorNotInCombat() then
		button:SetChecked(false)
		return
	end
	local frame = self:GetMovableFrame(button:GetParent().idx)
	if not frame then
		return
	end
	if button:GetChecked() then
		self:HideFrame(frame)
	else
		self:ShowFrame(frame)
	end
	self:UpdateGUIIfShown()
end

function MovAny:OnResetCheck( button )
	if self:ErrorNotInCombat() then
		return
	end
	self:ResetFrameOptions(self.frames[button:GetParent().idx].name)
end

function MovAny:HideFrame( frame )
	if not frame then
		return
	end
	if self:IsMAFrame(frame:GetName()) then
		return false
	end
	if not self:IsFrameHooked(frame:GetName()) then
		self:HookFrame( frame:GetName() )
	end
	
	local opt = self:GetFrameOptions(frame:GetName())
	opt.hidden = true
	frame.maWasShown = frame:IsShown()
	
	if self.HideList[ frame:GetName() ] then
		for hIndex, hideEntry in pairs(self.HideList[ frame:GetName() ]) do
			local val = getglobal(hideEntry[1])
			local hideType
			for i = 2, table.getn(hideEntry) do
				hideType = hideEntry[ i ]
				if type(hideType) == "function" then
					hideType(false)
				elseif hideType == "DISABLEMOUSE" then
					val:EnableMouse(false)
				elseif hideType == "FRAME" then
					self:PreventExternalVisibility(val)
				elseif hideType == "WH" then
					self:StopMoving(frame:GetName())
					val:SetWidth(1)
					val:SetHeight(1)
				else
					val:DisableDrawLayer( hideType )
				end
			end
		end
	elseif self.HideUsingWH[ frame:GetName() ] then
		self:StopMoving(frame:GetName())
		frame:SetWidth(1)
		frame:SetHeight(1)
	else
		self:PreventExternalVisibility(frame)
	end
end

function MovAny:ShowFrame( frame )
	if ( not frame ) then return; end
	local opt = self:GetFrameOptions( frame:GetName() );
	
	if( opt and opt.hidden ) then
		if( not opt.movable ) then
			-- if being hidden is the only thing we're controlling with this frame
			-- do a full reset instead of a simple show
			self:ResetFrameOptions(frame:GetName())
			return;
		end
	end

	if( opt ) then
		opt.hidden = nil;
	end
	if( self.HideList[ frame:GetName() ] ) then
		for hIndex, hideEntry in pairs(self.HideList[ frame:GetName() ]) do
			local val = getglobal( hideEntry[1] );
			local hideType;
			for i = 2, table.getn( hideEntry ) do
				hideType = hideEntry[i];
				if( type( hideType ) == "function" ) then
					hideType( true );
				elseif( hideType == "DISABLEMOUSE" ) then
					val:EnableMouse( true );
				elseif( hideType == "FRAME" ) then
					self:AllowExternalVisibility( val );
				elseif( hideType == "WH" ) then
					val:SetWidth( opt.originalWidth );
					val:SetHeight( opt.originalHeight );
				else
					val:EnableDrawLayer( hideType );
				end
			end
		end
	elseif( self.HideUsingWH[ frame:GetName() ] ) then
		frame:SetWidth( opt.originalWidth );
		frame:SetHeight( opt.originalHeight );
	else
		self:AllowExternalVisibility( frame );
	end
end

function MovAny:OnCheckCharacterSpecific( button )
	local oldName = self:GetSettingsName()
	if( button:GetChecked() ) then
		MoveAnything_UseCharacterSettings = true
		self:CopySettings(oldName, self:GetSettingsName())
	else
		MoveAnything_UseCharacterSettings = false
		self:CopySettings(oldName, self:GetSettingsName())
	end
	self:UpdateGUIIfShown()
end

function MovAny:OnCheckToggleCategories( button )
	local state = button:GetChecked()
	MADB.collapsed = state
	for i, v in pairs(self.cats) do
		v.collapsed = state
	end
	self:CountGUIItems()
	self:UpdateGUIIfShown()
end

function MovAny:SafeToMove()
	if UnitAffectingCombat("player") then
		return false
	else
		return true
	end
end

function MovAny:MoverOnSizeChanged( obj )
	if( obj.tagged ) then
		local s, w, h, opt

		opt = self:GetFrameOptions(obj.tagged:GetName())

		if self.ScaleWH[ obj.tagged:GetName() ] then
			-- if obj ever needs to apply to a frame with attached children,
			-- we're going to have to figure out what to do, since setting
			-- the W and H directly is definitely incorrect
			if opt then
				opt.width = obj:GetWidth()
				opt.height = obj:GetHeight()
			end
			
			self:SafeScale(obj.tagged, opt)
		else
			if obj.MASizingAnchor == "LEFT" or obj.MASizingAnchor == "RIGHT" then
				w = obj:GetWidth()
				h = w * (obj.tagged:GetHeight() / obj.tagged:GetWidth())
				if h < 16 then
					h = 16
					w = h * (obj.tagged:GetWidth() / obj.tagged:GetHeight())
				end
			else
				h = obj:GetHeight()
				w = h * (obj.tagged:GetWidth() / obj.tagged:GetHeight())
				if w < 16 then
					w = 16
					h = w * (obj.tagged:GetHeight() / obj.tagged:GetWidth())
				end
			end
			s = obj:GetWidth() / obj.tagged:GetWidth()
			s = s / MAGetScale(obj.tagged:GetParent(), 1 ) * UIParent:GetScale()

			if s > 0 and self:IsScalableFrame(obj.tagged:GetName()) then
				opt.scale = s
				self:SafeScale(obj.tagged, opt)
			end
			obj:SetWidth(w)
			obj:SetHeight(h)
		end
	end
end

function MovAny:MoverOnMouseWheel(mover)
	local alpha = this.tagged:GetAlpha()
	if arg1 > 0 then
		alpha = alpha + 0.05
	else
		alpha = alpha - 0.05
	end
	if alpha < 0.1 then
		alpha = 0.1
	elseif alpha > 1 then
		alpha = 1
	end
	this.tagged:SetAlpha(alpha)
end

function MovAny:UpdateGUIIfShown()
	if MAOptions and MAOptions:IsShown() then
		self:UpdateGUI();
	end
end

function MovAny:ResetAll()
	for i,v in pairs(self.FrameOptions) do
		self:ResetFrameOptions(v.name)
	end
	self.FrameOptions = {}
	self.guiLines = -1
	self:UpdateGUIIfShown()
end

function MovAny:OnShow()
	PlaySound("igMainMenuOpen")
	MANudger:Show()
	self:UpdateGUI()
end

function MovAny:OnHide()
	PlaySound("igMainMenuClose")
	self:MoverOnHide()
end

function MovAny:RowTitleClicked(title)
	local o = self.frames[ MAGetParent(title).idx ]
	
	if o.sep then
		if o.collapsed then
			o.collapsed = false
		else
			o.collapsed = true
		end
		
		self:CountGUIItems()
		self:UpdateGUI()
	end
end

function MovAny:CountGUIItems()
	local items = 0
	local sepLast = nil
	for i, o in pairs(MovAny.frames) do
		if o.sep then
			lastSep = o
			items = items + 1
		else
			if lastSep and lastSep.collapsed then
			else
				items = items + 1
			end
		end
	end
	self.guiLines = items
end

function MovAny:UpdateGUI()
	if self.guiLines == -1 then
		MovAny:CountGUIItems()
	end
	FauxScrollFrame_Update(MAScrollFrame, MovAny.guiLines, MovAny.frameListSize, MovAny.SCROLL_HEIGHT)
	local topOffset = FauxScrollFrame_GetOffset(MAScrollFrame)
	
	local startOffset = 0
	local hidden = 0
	local shown = 0
	local sepLast = nil
	for i, o in pairs(MovAny.frames) do
		if startOffset == 0 and shown >= topOffset then
			startOffset = shown + hidden
			break
		end
			
		if o.sep then
			lastSep = o
			if o.collapsed then
				hidden = hidden + o.items
			end
			shown = shown + 1
		else
			if lastSep and lastSep.collapsed then
			else
				shown = shown + 1
			end
		end
	end
	
	if startOffset ~= 0 then
		-- X: fix off by one
		if startOffset > 0 then
			startOffset = startOffset + 1
		end
	end
	
	local prefix, move, backdrop, hide, sepOffset, wtfOffset
	prefix = "MAMove"
	move = "Move"
	hide = "Hide"
	sepOffset = 0
	wtfOffset = 0
	
	for i=1, MovAny.frameListSize, 1 do
		local index = i + startOffset + sepOffset + wtfOffset
		
		local o
		-- fix mousewheel error
		while 1 do
			if index > MovAny.framesCount then
				break
			end
			o = MovAny.frames[ index ]
			if not o.cat then
				break
			end
			local c = o.cat
			if c.collapsed then
				index = index + 1
				wtfOffset = wtfOffset + 1
			else
				break
			end
		end
		
		local row = getglobal(prefix..i)
		
		if index > MovAny:GetFrameCount() then
			row:Hide()
		else
			local moveCheck = getglobal(prefix..i..move)
			local hideCheck = getglobal(prefix..i..hide)
			
			row.idx = index
			row.name = o.name
			row:Show()
			
			local text
			if o.sep then
				text = getglobal(prefix..i.."FrameNameText")
				text:Hide()
				text = getglobal(prefix..i.."FrameNameHighlight")
				text:Show()
				if o.collapsed then
					text:SetText("+ "..o.helpfulName)
				else
					text:SetText("   "..o.helpfulName)
				end
			else
				text = getglobal(prefix..i.."FrameNameHighlight")
				text:Hide()
				text = getglobal(prefix..i.."FrameNameText")
				text:Show()
				text:SetText(o.helpfulName)
			end
	
			local frameName = o.name
			local opt = MovAny:GetFrameOptions(frameName)
			if frameName then
				getglobal(prefix..i.."Backdrop"):Show()
				moveCheck:Show()
				
				if MovAny:GetMoverByFrameName(frameName) then
					moveCheck:SetChecked(1)
				else
					moveCheck:SetChecked(nil)
				end
				
				if MovAny.NoMove[ frameName ] then
					moveCheck:Hide()
				end
				
				if MovAny.NoHide[ frameName ] then
					hideCheck:Hide()
				else
					if opt and opt.hidden then
						hideCheck:SetChecked(1)
					else
						hideCheck:SetChecked(nil)
					end
					hideCheck:Show()
				end
				
				if MovAny:IsFrameHooked(frameName) then
					getglobal(prefix..i.."Reset"):Show()
				else
					if o.default then
						getglobal(prefix..i.."Reset"):Hide()
					else
						getglobal(prefix..i.."Reset"):Show()
					end
				end
			else
				getglobal(prefix..i.."Backdrop"):Hide()
				moveCheck:Hide()
				hideCheck:Hide()
				getglobal(prefix..i.."Reset"):Hide()
			end
			
			if o.sep and o.collapsed then
				sepOffset = sepOffset + o.items
			end
		end
	end
	
	if( MoveAnything_UseCharacterSettings) then
		MAOptionsCharacterSpecific:SetChecked(1)
	else
		MAOptionsCharacterSpecific:SetChecked(nil)
	end
end

function MovAny:Mover(dir)
	if ( dir > 0 ) then
		if ( self.CurrentMover < 20 ) then
			self.CurrentMover = self.CurrentMover + 1;
		else
			return;
		end
	else
		if ( MovAny.CurrentMover > 1 ) then
			self.CurrentMover = self.CurrentMover - 1;
		else
			return;
		end
	end
	self:NudgerFrameRefresh();
end

function MovAny:GetFirstMover()
	for i = 1, 20 do
		if ( getglobal("MoveAnything"..i):IsShown() ) then
			return i;
		end
	end
end

function MovAny:MoverOnShow(mover)
	MANudger:Show();
	self.CurrentMover = tonumber(mover:GetID());
	self:NudgerFrameRefresh();
end

function MovAny:MoverOnHide()
	local firstMover = self:GetFirstMover();
	if ( firstMover ) then
		self.CurrentMover = firstMover;
		self:NudgerFrameRefresh();
	elseif ( MAOptions:IsShown() ) then
		self.CurrentMover = 1;
		self:NudgerFrameRefresh(1);
	else
		MANudger:Hide();
	end
end

function MovAny:NudgerOnShow()
	self:NudgerFrameRefresh();
end

function MovAny:NudgerFrameRefresh(reset)
	if ( self.CurrentMover < 20 ) then
		MANudger_MoverPlus:Enable();
	else
		MANudger_MoverPlus:Disable();
	end
	if ( self.CurrentMover > 1 ) then
		MANudger_MoverMinus:Enable();
	else
		MANudger_MoverMinus:Disable();
	end

	local labelText = "MA "..self.CurrentMover.."/20";
	if ( not reset and getglobal("MoveAnything"..self.CurrentMover).tagged ) then
		labelText = labelText.."\n"..getglobal("MoveAnything"..self.CurrentMover).tagged:GetName();
	end
	MANudgerTitle:SetText(labelText);
end

function MovAny:NudgerOnUpdate()
	-- This code was originally ripped from DiscordART :)
	local obj = GetMouseFocus()
	local text = ""
	local text2 = ""
	local label = MANudgerMouseOver
	local labelSafe = MANudgerMouseOver
	
	if (obj and obj ~= WorldFrame and obj:GetName()) then
		local objTest = self:GetDefaultFrameParent(obj)
		if objTest then
			text = text.."Safe: "..objTest:GetName()
		else
			objTest = self:GetTopFrameParent(obj)
			if objTest then
				text = text.."Safe: "..objTest:GetName()
			end
		end
	end

	if (obj and obj ~= WorldFrame and obj:GetName()) then
		text2 = "Mouseover: "..text2..obj:GetName()
		if (obj:GetParent()  and obj:GetParent() ~= WorldFrame and obj:GetParent():GetName() ) then
			text2 = text2.."\nParent: "..obj:GetParent():GetName()
			if (obj:GetParent():GetParent() and obj:GetParent():GetParent() ~= WorldFrame and obj:GetParent():GetParent():GetName()) then
				text2 = text2.."\nParent's Parent: "..obj:GetParent():GetParent():GetName()
			end
		end
	end
	
	if ( not string.find(text2, "MANudger") ) then
		label:SetText(text2.."\n"..text)
	else
		label:SetText(text)
	end
end

function MovAny:Center(lock)
	local mover = getglobal("MoveAnything"..self.CurrentMover);
	if ( lock == 0 ) then
		-- Both
		mover:ClearAllPoints();
		mover:SetPoint("CENTER",0,0);
	else
		local x, y;
		x = mover:GetLeft();
		y = mover:GetBottom();

		mover:ClearAllPoints();
		if ( lock == 1 ) then
			--Horizontal
			mover:SetPoint("CENTER",0,0);
			x = mover:GetLeft();
			mover:ClearAllPoints();
			mover:SetPoint("BOTTOMLEFT",x,y);
		elseif ( lock == 2 ) then
			-- Vertical
			mover:SetPoint("CENTER",0,0);
			y = mover:GetBottom();
			mover:ClearAllPoints();
			mover:SetPoint("BOTTOMLEFT",x,y);
		end
	end

	self:UpdatePosition(mover);
end

function MovAny:Nudge(dir, button)
	local x, y, offsetX, offsetY, parent, mover, offsetAmount;
	mover = getglobal("MoveAnything"..self.CurrentMover);

	if ( not mover:IsShown() ) then
		return;
	end

	x = mover:GetLeft();
	y = mover:GetBottom();

	if ( button == "RightButton" ) then
		if ( IsShiftKeyDown() ) then
			offsetAmount = 250;
		else
			offsetAmount = 50;
		end
	else
		if ( IsShiftKeyDown() ) then
			offsetAmount = 10;
		else
			offsetAmount = 1;
		end
	end

	if ( dir == 1 ) then
		offsetX = 0;
		offsetY = offsetAmount;
	elseif ( dir == 2 ) then
		offsetX = 0;
		offsetY = -offsetAmount;
	elseif ( dir == 3 ) then
		offsetX = -offsetAmount;
		offsetY = 0;
	elseif ( dir == 4 ) then
		offsetX = offsetAmount;
		offsetY = 0;
	end

	mover:ClearAllPoints();
	mover:SetPoint("BOTTOMLEFT","UIParent","BOTTOMLEFT",x + offsetX, y + offsetY);
	self:UpdatePosition(mover);
end

function MovAny:SizingAnchor( button )
	local s, e = string.find( button:GetName(), "Resize_" )
	local anchorto = string.sub( button:GetName(), e + 1 );
	local anchor;

	if( anchorto == "LEFT" ) then anchor = "RIGHT";
	elseif( anchorto == "RIGHT" ) then anchor = "LEFT";
	elseif( anchorto == "TOP" ) then anchor = "BOTTOM";
	elseif( anchorto == "BOTTOM" ) then anchor = "TOP";
	end
	return anchorto, anchor;
end

function MovAny:SetLeftFrameLocation()
	local left = GetUIPanel("left")
	if left then
		if self:IsFrameHooked("UIPanelMover1") then
			left:ClearAllPoints()
			left:SetPoint("TOPLEFT", "UIPanelMover1", "TOPLEFT", 0)
			left:SetScale(MAGetScale( UIPanelMover1 ), 1)
		else
			left:SetScale(1)
		end
	end
end

function MovAny:SetCenterFrameLocation()
	-- don't mess with the normal center panels, just the ones
	-- that are pushed over from the left
	if GetUIPanel("left") then
		local center = GetUIPanel("center")
		if center then
			if self:IsFrameHooked("UIPanelMover2" ) then
				center:ClearAllPoints()
				center:SetPoint("TOPLEFT", "UIPanelMover2", "TOPLEFT")
				center:SetScale(MAGetScale( UIPanelMover2 ), 1)
			else
				center:SetScale(1)
			end
		end
	end
end

function MovAny:GetContainerFrame( id )
	local i = 1
	local container
	while 1 do
		container = getglobal("ContainerFrame"..i)
		if not container then break end
		if container:IsShown() and container:GetID() == id then
			return container
		end
		i = i + 1
	end
	return nil
end

function MovAny:GetBagInContainerFrame( frame )
	return self:GetBag(frame:GetID())
end

function MovAny:GetBag(id)
	return self.bagFrames[ id ]
end

function MovAny:SetBag(id, bag)
	self.bagFrames[ id ] = bag
end

function MovAny:GrabContainerFrame( container, movableBag )
	if movableBag and MovAny:IsFrameHooked(movableBag:GetName()) then
		MovAny:PreventExternalMovement(container)
		container.MAContainerOriginalScale = MAGetScale(container)
		movableBag:Show()
		
		container:HiddenClearAllPoints()
		container:HiddenSetScale(MAGetScale( movableBag ))
		container:HiddenSetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", movableBag:GetLeft(), movableBag:GetBottom())
		--container:HiddenSetPoint("BOTTOMLEFT", movableBag:GetName(), "BOTTOMLEFT", 0, 0)
		--]]--
		movableBag.attachedChildren = {}
		table.insert(movableBag.attachedChildren, container)
	end
end

-- modfied version of blizzards own updateContainerFrameAnchors
function MovAny:UpdateContainerFrameAnchors()
  local frame, xOffset, yOffset, screenHeight, freeScreenHeight, leftMostPoint, column;
  local screenWidth = GetScreenWidth();
  local containerScale = 1;
  local leftLimit = 0;
  --[[
  if ( BankFrame:IsShown() ) then
    leftLimit = BankFrame:GetRight() - 25;
  end
  ]]--
  
  while ( containerScale > CONTAINER_SCALE ) do
    screenHeight = GetScreenHeight() / containerScale;
    -- Adjust the start anchor for bags depending on the multibars
    xOffset = CONTAINER_OFFSET_X / containerScale;
    yOffset = CONTAINER_OFFSET_Y / containerScale;
    -- freeScreenHeight determines when to start a new column of bags
    freeScreenHeight = screenHeight - yOffset;
    leftMostPoint = screenWidth - xOffset;
    column = 1;
    local frameHeight;
    for index, frameName in ipairs(ContainerFrame1.bags) do
      frameHeight = getglobal(frameName):GetHeight();
      if ( freeScreenHeight < frameHeight ) then
        -- Start a new column
        column = column + 1;
        leftMostPoint = screenWidth - ( column * CONTAINER_WIDTH * containerScale ) - xOffset;
        freeScreenHeight = screenHeight - yOffset;
      end
      freeScreenHeight = freeScreenHeight - frameHeight - VISIBLE_CONTAINER_SPACING;
    end
    if ( leftMostPoint < leftLimit ) then
      containerScale = containerScale - 0.01;
    else
      break;
    end
  end
  
  if ( containerScale < CONTAINER_SCALE ) then
    containerScale = CONTAINER_SCALE;
  end
  
  screenHeight = GetScreenHeight() / containerScale;
  -- Adjust the start anchor for bags depending on the multibars
  xOffset = CONTAINER_OFFSET_X / containerScale;
  yOffset = CONTAINER_OFFSET_Y / containerScale;
  -- freeScreenHeight determines when to start a new column of bags
  freeScreenHeight = screenHeight - yOffset;
  column = 0;
  
  local bag = nil
  local lastBag = nil
  for index, frameName in ipairs(ContainerFrame1.bags) do
    frame = getglobal(frameName);
    bag = MovAny:GetBagInContainerFrame(frame)
    if not bag or ( bag and not MovAny:IsFrameHooked(bag:GetName()) ) then
	    frame:SetScale(containerScale);
	    frame:ClearAllPoints()
	    if ( lastBag == nil ) then
	      -- First bag
	      frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", GetScreenWidth()-xOffset-CONTAINER_WIDTH, yOffset );
	    elseif ( freeScreenHeight < frame:GetHeight() ) then
	      -- Start a new column
	      column = column + 1;
	      freeScreenHeight = screenHeight - yOffset;
	      frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -(column * CONTAINER_WIDTH) - xOffset, yOffset );
	    else
	      -- Anchor to the previous bag
	      frame:SetPoint("BOTTOMRIGHT", lastBag, "TOPRIGHT", 0, CONTAINER_SPACING);
	    end
	    freeScreenHeight = freeScreenHeight - frame:GetHeight() - VISIBLE_CONTAINER_SPACING;

	    lastBag = frame
	   end
  end
end

----------------------------------------------------------------

function MovAny_HiddenShow( obj )
	obj.maWasShown = true;
end

function MovAny_HiddenHide( obj )
	obj.maWasShown = false;
end

function MovAny_HiddenIsVisible( obj )
	return obj.maWasShown;
end

----------------------------------------------------------------
-- X: slash commands

SLASH_MAMOVE1 = "/move"
SlashCmdList["MAMOVE"] = function( msg )
	if MovAny:SafeToMove() then
		if msg == nil or string.len( msg ) == 0 then
			MovAny:ToggleOptionsMenu()
		else
			MovAny:ToggleMove(MovAny:Translate(msg))
		end
	else
		MovAny:ErrorNotInCombat()
	end
end

SLASH_MAUNMOVE1= "/unmove"
SlashCmdList["MAUNMOVE"] = function( msg )
	if msg then
		if MovAny.FrameOptions[ msg ] then
			MovAny:ResetFrameOptions(msg)
		elseif MovAny.FrameOptions[ MovAny:Translate(msg) ] then
			MovAny:ResetFrameOptions(MovAny:Translate(msg))
		end
	else
		Error("Syntax: /unmove framename")
	end
end

SLASH_MACOPY1 = "/movecopy"
SlashCmdList["MACOPY"] = function( msg )
	if msg == nil or string.len(msg) == 0 then
		Error("Syntax: /movecopy ServerName PlayerName")
		return
	end

	if MoveAnything_CharacterSettings[msg] == nil then
		Error("No settings for server/character "..msg)
		return
	end

	MovAny:CopySettings(msg, MovAny:GetSettingsName())
end


SLASH_MALIST1 = "/movelist"
SlashCmdList["MALIST"] = function( msg )
	maPrint("Server/Character Settings List:")
	maPrint("-------------------------------")
	for i, val in pairs(MoveAnything_CharacterSettings) do
		local str = i
		if  val == MovAny.FrameOptions then
			str = str.." (Current)"
		end
		maPrint(str)
	end
end

SLASH_MADELETE1 = "/movedelete"
SLASH_MADELETE2 = "/movedel"
SlashCmdList["MADELETE"] = function( msg )
	if( msg == nil or string.len( msg ) == 0 ) then
		Error( "Syntax: /movedelete ServerName PlayerName" );
		return
	end

	if( MoveAnything_CharacterSettings[msg] == nil ) then
		Error( "No settings for server/character "..msg )
		return;
	end

	if( msg == MovAny:GetSettingsName() ) then
		MovAny:ResetAll();
	else
		MoveAnything_CharacterSettings[msg] = nil;
	end
	MovAny.FrameOptions = MoveAnything_CharacterSettings[MovAny:GetSettingsName()];
	MovAny:RefreshPositions();
end
----------------------------------------------------------------
-- X: global functions

if not table.find then
	function table.find( table, value )
		for i, v in pairs(table) do
			if( v == value ) then
				return i;
			end
		end
		return nil;
	end
end

function MoveAnythingUpdater_OnUpdate(arg1)
	if MoveAnythingUpdater:GetScale() == UIParent:GetScale() then
		MoveAnythingUpdater:SetScale(0.2)
		MovAny:RefreshPositions()
	end
end

function MAGetParent( frame )
	if ( not frame or not frame.GetParent ) then return; end
	if( frame:GetParent() == nil ) then
		return UIParent;
	end

	return frame:GetParent();
end

function MAGetScale( frame, effective )
	if not frame or MovAny.NoMove[frame:GetName()] then
		return 1;
	else
		if( not frame.GetScale or frame:GetScale() == nil ) then
			return 1;
		end
	
		if ( effective ) then
			return frame:GetEffectiveScale();
		else
			return frame:GetScale();
		end
	end
end

function maPrint( msgKey, msgHighlight, msgAdditional, r, g, b, frame )
	local msgOutput 
	if ( frame ) then
		msgOutput = frame
	else
		msgOutput = DEFAULT_CHAT_FRAME;
	end
	
	if msgKey				 == "" then return; end;
	if msgKey        == nil then msgKey = "<nomsg>"; end;    
	if msgHighlight  == nil or msgHighlight  == "" then msgHighlight  = " "; end;
	if msgAdditional == nil or msgAdditional == "" then msgAdditional = " "; end;
	if( msgOutput ) then
		msgOutput:AddMessage( "|caaff0000MoveAnything|r|caaffff00>|r "..msgKey.." |caaaaddff"..msgHighlight.."|r"..msgAdditional, r, g, b )
	end
end;

----------------------------------------------------------------
-- X: debugging code

function echo(...) 
	local msg = ""
	for k,v in pairs({...}) do
		msg = msg .. k .. "=[" .. tostring(v) .."] "
	end
	DEFAULT_CHAT_FRAME:AddMessage(msg)
end

function MovAny:DebugFrameAtCursor()
	local o = GetMouseFocus()
	if o and o ~= WorldFrame and o ~= UIParent then
		MovAny:Dump(o)
	end
end
	
function MovAny:Dump(o)
	maPrint("Name: "..o:GetName())
	if o:GetTop() then
		maPrint("Top: "..o:GetTop())
	end
	if o:GetRight() then
	maPrint("Right: "..o:GetRight())
	end
	if o:GetBottom() then
	maPrint("Bottom: "..o:GetBottom())
	end
	if o:GetLeft() then
	maPrint("Left: "..o:GetLeft())
	end
	if o:GetHeight() then
	maPrint("Height: "..o:GetHeight())
	end
	if o:GetWidth() then
	maPrint("Width: "..o:GetWidth())
	end
	maPrint("Scale: "..o:GetScale())
	maPrint("Scale Effective: "..o:GetEffectiveScale())
	maPrint("Alpha: "..o:GetAlpha())
	maPrint("Alpha Effective: "..o:GetEffectiveAlpha())
	maPrint("Level: "..o:GetFrameLevel())
	maPrint("Strata: "..o:GetFrameStrata())
	maPrint("Type: "..o:GetFrameType())
	if o:IsUserPlaced() then
		maPrint("Moved: "..o:IsUserPlaced())
	end
	if o:IsMovable() then
		maPrint("Movable: "..o:IsMovable())
	end
	if o:IsResizable() then
		maPrint("Resizable: "..o:IsResizable())
	end
	if o:IsToplevel() then
		maPrint("Top Level: "..o:IsToplevel())
	end
	if o:IsKeyboardEnabled() then
		maPrint("Keyboard: "..o:IsKeyboardEnabled())
	end
	if o:IsMouseEnabled() then
		maPrint("Mouse: "..o:IsMouseEnabled())
	end
	if o:IsMouseWheelEnabled() then
		maPrint("Mouse Wheel: "..o:IsMouseWheelEnabled())
	end
	
	local opts = self:GetFrameOptions(o:GetName())
	if opts ~= nil then
		maPrint("Frame options:")
		for i,v in pairs(opts) do
			echo(i,v)
		end
	end
end

SLASH_MADBG1 = "/madbg"
SlashCmdList["MADBG"] = function( msg )
	if msg == nil then
		MADebug()
		return
	end
	local f = getglobal(msg)
	if f == nil then
		maPrint(msg.." not found")
	else
		MovAny:Dump(f)
	end
end

function MADebug()
	maPrint("Frames: "..table.getn(MovAny.Frames));
	for i in pairs(MovAny.Frames) do
		maPrint(MovAny.Frames[i].name);
	end
	
	maPrint( table.getn( MoveAnything_CustomFrames ).." custom frames" );
	for i, v in pairs(MoveAnything_CustomFrames) do
		maPrint( v.name );
	end
	
	maPrint( table.getn( MovAny.FrameOptions ).." frame options" );
	for i, v in pairs(MovAny.FrameOptions) do
		maPrint( "FrameOptions: "..v.name );
	end
end

-- X: http://lua-users.org/wiki/CopyTable
function deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end
